VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private oServer As core.CServer

'*********************** DECLARES OS VERSION INFO ********************
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128 ' Maintenance string For PSS usage
End Type

Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (dest As Any, ByVal numBytes As Long)
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, cbName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As Any) As Long

' Reg Key Security Options
' Const READ_CONTROL = &H20000
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const SYNCHRONIZE = &H100000
Private Const ERROR_NO_MORE_ITEMS = 259&
Private Const ERROR_SUCCESS = 0&
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
'Const STANDARD_RIGHTS_READ = (READ_CONTROL)
'Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))

Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Private Const REG_CREATED_NEW_KEY = &H1                      ' New Registry Key created
Private Const REG_OPTION_NON_VOLATILE = 0
Private Const REG_OPTION_RESERVED = 0
Private Const REG_OPTION_VOLATILE = 1
Private Const MAXIMUM_ALLOWED = &H2000000

Private Declare Function OpenProcessToken Lib "Advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function GetTokenInformation Lib "Advapi32" (ByVal TokenHandle As Long, TokenInformationClass As Integer, TokenInformation As Any, ByVal TokenInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Const TOKEN_QUERY = &H8
Private Const TokenStatistics = 10

Private Type LUID
    LowPart As Long
    HighPart As Long
End Type

Private Type TOKEN_STATISTICS
    TokenId As LUID
    AuthenticationId As LUID
    ExpirationTime As Long
    TokenType As Long
    ImpersonationLevel As Long
    DynamicCharged As Long
    DynamicAvailable As Long
    GroupCount As Long
    PrivilegeCount As Long
    ModifiedId As LUID
End Type

Private Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Private Type PROCESS_INFORMATION
   hProcess As Long
   hThread As Long
   dwProcessID As Long
   dwThreadID As Long
End Type


Private Const NORMAL_PRIORITY_CLASS = &H20&
Private Const INFINITE = -1&

Private Const MAX_PATH = 260

Private Enum SHSpecialFolderIDs
  CSIDL_DESKTOP = &H0
  CSIDL_INTERNET = &H1
  CSIDL_PROGRAMS = &H2
  CSIDL_CONTROLS = &H3
  CSIDL_PRINTERS = &H4
  CSIDL_PERSONAL = &H5
  CSIDL_FAVORITES = &H6
  CSIDL_STARTUP = &H7
  CSIDL_RECENT = &H8
  CSIDL_SENDTO = &H9
  CSIDL_BITBUCKET = &HA
  CSIDL_STARTMENU = &HB
  CSIDL_DESKTOPDIRECTORY = &H10
  CSIDL_DRIVES = &H11
  CSIDL_NETWORK = &H12
  CSIDL_NETHOOD = &H13
  CSIDL_FONTS = &H14
  CSIDL_TEMPLATES = &H15
  CSIDL_COMMON_STARTMENU = &H16
  CSIDL_COMMON_PROGRAMS = &H17
  CSIDL_COMMON_STARTUP = &H18
  CSIDL_COMMON_DESKTOPDIRECTORY = &H19
  CSIDL_APPDATA = &H1A
  CSIDL_PRINTHOOD = &H1B
  CSIDL_ALTSTARTUP = &H1D                      ' ' DBCS
  CSIDL_COMMON_ALTSTARTUP = &H1E    ' ' DBCS
  CSIDL_COMMON_FAVORITES = &H1F
  CSIDL_INTERNET_CACHE = &H20
  CSIDL_COOKIES = &H21
  CSIDL_HISTORY = &H22
End Enum

Private Enum HKeys
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum
    
Private m_sName As String
Public Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim sPath As String
    
    m_sName = Name
    Set oServer = CreateObject("core.CServer")
    
    ' Unless the shift key is pressed, lets get to work
    If GetAsyncKeyState(vbKeyShift) = 0 Then
        ' If this is the first run for this session, or we are on a win9x system, lets get to work
        If IsFirstRunThisSession Then
            ' Load the HKLM RunOnce first
            If oServer.evalBool(oServer.GetKey(Name, "runonce")) Then
                RunEntriesIn HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\RunOnce"
                DeleteEntriesIn HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\RunOnce"
            End If
            
            ' Load the HKLM Run second, and HKCU Run third
            If oServer.evalBool(oServer.GetKey(Name, "run")) Then
                RunEntriesIn HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\Run"
                RunEntriesIn HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run"
            End If
            
            ' Then run the startup folder(s)
            If oServer.evalBool(oServer.GetKey(Name, "startup")) Then
            
                If fGetSystemFolderPath(oServer.GetDesktop, CSIDL_STARTUP, sPath) Then
                    RunFolder sPath
                End If
            
                If fGetSystemFolderPath(oServer.GetDesktop, CSIDL_COMMON_STARTUP, sPath) Then
                    RunFolder sPath
                End If
            
            End If
        
            ' Finish of with the HKCU RunOnce
            If oServer.evalBool(oServer.GetKey(Name, "runonce")) Then
                RunEntriesIn HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\RunOnce"
                DeleteEntriesIn HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\RunOnce"
            End If
        Else
            oServer.Execute "!log core.startup skiping startup items (already run once this session)"
        End If
    Else
        oServer.Execute "!log core.startup skiping startup items (shift pressed)"
    End If

    IBasePlugin_StartPlugin = 0

End Function
Private Sub IBasePlugin_StopPlugin()
    
End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)
   
End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Function RunFolder(sPath As String)

    Dim textline As String
    
    textline = Dir(sPath & "\*.*")
    While textline <> ""
        oServer.Execute sPath & "\" & textline
        oServer.Execute "!log core.startup started " & textline
'        Call Shell(sPath & "\" & textline, vbNormalFocus)
        textline = Dir
    Wend

End Function
Private Function RunEntriesIn(key As HKeys, Path As String)
    
    Dim hKey As Long
    Dim lResult As Long
    Dim szNameBuffer As String * 1024
    Dim szValueBuffer As String * 1024
    Dim dwLoop As Integer
    Dim proc As PROCESS_INFORMATION
    Dim start As STARTUPINFO
    Dim ret As Long
    
    On Error Resume Next
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Do
            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, Len(szNameBuffer), 0, 0, szValueBuffer, Len(szValueBuffer))
            If lResult = ERROR_SUCCESS Then
                ' Initialize the STARTUPINFO structure:
                ZeroMemory start, Len(start)
                start.cb = Len(start)

                ' Start the shelled application:
                ret = CreateProcessA(0&, szValueBuffer, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)
                Call CloseHandle(proc.hThread)
                Call CloseHandle(proc.hProcess)
                oServer.Execute "!log core.startup started " & Left(szValueBuffer, InStr(1, szValueBuffer, Chr(0)) - 1)
            Else
                Call RegCloseKey(hKey)
                Exit Function
            End If
            dwLoop = dwLoop + 1
        Loop
        Call RegCloseKey(hKey)
    End If
    On Error GoTo 0

End Function
Private Function DeleteEntriesIn(key As HKeys, Path As String)
    
    Dim hKey  As Long
    Dim lResult As Long
    
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Dim szNameBuffer As String * 1024, szValueBuffer As String * 1024
        Dim dwLoop As Long, dwNameSize As Long, dwValueSize As Long
        Do
            dwNameSize = Len(szNameBuffer)
            dwValueSize = Len(szValueBuffer)

            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, dwNameSize, 0, 0, szValueBuffer, dwValueSize)
            If (lResult = ERROR_NO_MORE_ITEMS) Then
                Call RegCloseKey(hKey)
                Exit Function
            End If
            If (lResult = ERROR_SUCCESS) Then
                lResult = RegDeleteValue(hKey, szNameBuffer)
            End If
            If (lResult <> ERROR_SUCCESS) Then
                Call RegCloseKey(hKey)
                Exit Function
            End If
        Loop
        Call RegCloseKey(hKey)
    End If

End Function
Private Function fGetSystemFolderPath(ByVal hWnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(hWnd, Id, lPidl)  ' Get lPidl for Id...
    If lReturn = 0 Then                                    ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)        '   Get Path from Item Id List
        If lReturn = 1 Then                                '   If success is 1
            sPath = Trim$(sPath)                           '     Fix path string
            lPath = Len(sPath)                             '     Get length of path
            If Asc(Right$(sPath, 1)) = 0 Then lPath = lPath - 1 'Adjust path length
            If lPath > 0 Then sfPath = Left$(sPath, lPath) '     Adjust path string variable
            fGetSystemFolderPath = True                    '     Return success
        End If
    End If

End Function

' Ported from some code i got from Daij-Djan, dono who uncovered it first, to community sprit amongs the developers kicks ass!
Private Function IsFirstRunThisSession() As Boolean

    Dim bReturn As Boolean
    Dim hToken As Long
    Dim tsStats As TOKEN_STATISTICS
    Dim dwOutSize As Long
    Dim wsSessionInfo As String
    Dim lResult As Long
    Dim BufferSize As Long
    Dim hkExplorer As Long
    Dim hkSessionInfo As Long
    Dim hkStartup As Long
    Dim dwDisposition As Long
    Dim Infobuffer() As Long
    Dim y As SECURITY_ATTRIBUTES
    Dim OSINFO As OSVERSIONINFO
    
    bReturn = False
    
    OSINFO.dwOSVersionInfoSize = 148
    OSINFO.szCSDVersion = Space$(128)
    GetVersionEx OSINFO
          
    If OSINFO.dwPlatformId = 2 Then
        lResult = OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, hToken)
        If lResult > 0 Then
        ' Deternine the buffer size required
            Call GetTokenInformation(hToken, ByVal TokenStatistics, 0, 0, BufferSize) ' Determine required buffer Size
            If BufferSize Then
                ReDim Infobuffer((BufferSize \ 4) - 1) As Long
               ' Retrieve your token information
                lResult = GetTokenInformation(hToken, ByVal TokenStatistics, Infobuffer(0), BufferSize, BufferSize)
                If lResult = 1 Then
                    CloseHandle (hToken)
                    ' Get AuthenticationId.HighPart and AuthenticationId.LowPart from the returned data
                    wsSessionInfo = "SessionInfo\" & Pad(Hex(Infobuffer(3))) & Pad(Hex(Infobuffer(2)))
                    lResult = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer", 0, "", REG_OPTION_NON_VOLATILE, MAXIMUM_ALLOWED, y, hkExplorer, dwDisposition)
                    If lResult = ERROR_SUCCESS Then
                        lResult = RegCreateKeyEx(hkExplorer, wsSessionInfo, 0, "", REG_OPTION_VOLATILE, KEY_WRITE, y, hkSessionInfo, dwDisposition)
                        RegCloseKey hkExplorer
                        If lResult = ERROR_SUCCESS Then
                            lResult = RegCreateKeyEx(hkSessionInfo, "StartupHasBeenRun", 0, "", REG_OPTION_VOLATILE, KEY_WRITE, y, hkStartup, dwDisposition)
                            RegCloseKey (hkSessionInfo)
                            RegCloseKey (hkStartup)
                            If dwDisposition = REG_CREATED_NEW_KEY Then
                                bReturn = True
                            End If
                        End If
                    End If
                End If
            End If
        End If
    Else
        ' Win9x, not supported
        bReturn = True
    End If
    IsFirstRunThisSession = bReturn

End Function
Private Function Pad(what As String) As String

    While Len(what) < 8
        what = "0" & what
    Wend
    Pad = what

End Function
